<html>
<head>
<title>OgreUnifiedHighLevelGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreUnifiedHighLevelGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreUnifiedHighLevelGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __UnifiedHighLevelGpuProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __UnifiedHighLevelGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgramManager_8h.html">OgreHighLevelGpuProgramManager.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00060"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html">00060</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to one other high level...">UnifiedHighLevelGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html">00064</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html" title="Command object for setting delegate (can set more than once)">CmdDelegate</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066         <span class="keyword">public</span>:
<a name="l00067"></a>00067             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00068"></a>00068             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00069"></a>00069         };
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keyword">protected</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a7a8a017bf089486c19feed2bf671a36f">00072</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html" title="Command object for setting delegate (can set more than once)">CmdDelegate</a> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a7a8a017bf089486c19feed2bf671a36f">msCmdDelegate</a>;
<a name="l00073"></a>00073 
<a name="l00075"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a363bfe4317112b7b810115f9c2abf7d1">00075</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a363bfe4317112b7b810115f9c2abf7d1" title="Ordered list of potential delegates.">mDelegateNames</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a7c113a6bbe545bb30b619805dca5a82f">00077</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#a7c113a6bbe545bb30b619805dca5a82f" title="The chosen delegate.">mChosenDelegate</a>;
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> chooseDelegate() <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>);
<a name="l00083"></a>00083         <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00084"></a>00084         <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span>;
<a name="l00085"></a>00085         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to one other high level...">UnifiedHighLevelGpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00090"></a>00090             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00091"></a>00091         ~<a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to one other high level...">UnifiedHighLevelGpuProgram</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00098"></a>00098         <span class="keywordtype">void</span> addDelegateProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00099"></a>00099 
<a name="l00101"></a>00101         <span class="keywordtype">void</span> clearDelegatePrograms();
<a name="l00102"></a>00102 
<a name="l00104"></a>00104         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; _getDelegate() <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00116"></a>00116         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118         <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* _getBindingDelegate(<span class="keywordtype">void</span>);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         <span class="comment">// All the following methods must delegate to the implementation</span>
<a name="l00121"></a>00121 
<a name="l00123"></a>00123         <span class="keywordtype">bool</span> isSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00124"></a>00124         
<a name="l00126"></a>00126         <span class="keywordtype">bool</span> isSkeletalAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keywordtype">bool</span> isMorphAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130         <span class="keywordtype">bool</span> isPoseAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         <span class="keywordtype">bool</span> isVertexTextureFetchRequired(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00133"></a>00133         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> getDefaultParameters(<span class="keywordtype">void</span>);
<a name="l00134"></a>00134         <span class="keywordtype">bool</span> hasDefaultParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00135"></a>00135         <span class="keywordtype">bool</span> getPassSurfaceAndLightStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00136"></a>00136         <span class="keywordtype">bool</span> getPassFogStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00137"></a>00137         <span class="keywordtype">bool</span> getPassTransformStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00138"></a>00138         <span class="keywordtype">bool</span> hasCompileError(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00139"></a>00139         <span class="keywordtype">void</span> resetCompileError(<span class="keywordtype">void</span>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141         <span class="keywordtype">void</span> load(<span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00142"></a>00142         <span class="keywordtype">void</span> reload(<span class="keywordtype">void</span>);
<a name="l00143"></a>00143         <span class="keywordtype">bool</span> isReloadable(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00144"></a>00144         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00145"></a>00145         <span class="keywordtype">bool</span> isLoading() <span class="keyword">const</span>;
<a name="l00146"></a>00146         <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> getLoadingState() <span class="keyword">const</span>;
<a name="l00147"></a>00147         <span class="keywordtype">void</span> unload(<span class="keywordtype">void</span>);
<a name="l00148"></a>00148         <span class="keywordtype">size_t</span> getSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00149"></a>00149         <span class="keywordtype">void</span> touch(<span class="keywordtype">void</span>);
<a name="l00150"></a>00150         <span class="keywordtype">bool</span> isBackgroundLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00151"></a>00151         <span class="keywordtype">void</span> setBackgroundLoaded(<span class="keywordtype">bool</span> bl);
<a name="l00152"></a>00152         <span class="keywordtype">void</span> escalateLoading();
<a name="l00153"></a>00153         <span class="keywordtype">void</span> addListener(<a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>* lis);
<a name="l00154"></a>00154         <span class="keywordtype">void</span> removeListener(<a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>* lis);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     };
<a name="l00157"></a>00157 
<a name="l00159"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html">00159</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html" title="Factory class for Unified programs.">UnifiedHighLevelGpuProgramFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramFactory.html" title="Interface definition for factories of HighLevelGpuProgram.">HighLevelGpuProgramFactory</a>
<a name="l00160"></a>00160     {
<a name="l00161"></a>00161     <span class="keyword">public</span>:
<a name="l00162"></a>00162         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#acca4706f7fc63cb7db6892f4571af5dc">UnifiedHighLevelGpuProgramFactory</a>();
<a name="l00163"></a>00163         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#a4bcd1224c7aebfd90b777337ef3b6a43">~UnifiedHighLevelGpuProgramFactory</a>();
<a name="l00165"></a>00165         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#a3e96efa421a2c76c101a9ed4fcc64c25" title="Get the name of the language this factory creates programs for.">getLanguage</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00166"></a>00166         <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>* <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#a1660f65a2992bb11ab8ca778d9db35a5">create</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, 
<a name="l00167"></a>00167             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00168"></a>00168             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00169"></a>00169         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#af82a2c2bac74d8bcc903db82160c5d7e">destroy</a>(<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>* prog);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     };
<a name="l00172"></a>00172 
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
